//*****************************************
// AVR ATmega328 8x8 LED Clock
// CPU Clock:8MHz
//   UWlgɂ

// File Name:gps_clock.c
//
//
//  2022/09/10 New TAB4 Taishi
//  2023/02/25 Modify for pr_mega328_8x8dot_clock Taishi
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"pr_mega328_8x8dot_clock_h.h"
#include	"port_bit_h.h"
#include	"display_h.h"
#include	"uart_h.h"
#include	"infrared_h.h"
#include	"gps_clock_h.h"


unsigned char			Ggps_data[GPS_RX_NUMBER_MAX+2];				// Mf[^ifobOpj
unsigned char			Grymd[4]  ={'Y',':',' ',0};					// fobOpf[^NL
unsigned char			Grhms[4]  ={'H',':',' ',0};					// fobOpf[^bL
unsigned char			Grvalid[4]={'V',':',' ',0};					// fobOpf[^L
unsigned char			Gdata_page[4] = {'P',':',' ',0};			// fobOpforf[^y[W
unsigned char			Gdata_err[4] = {'E',':',' ',0};				// fobOpf[^G[iT`FbNj
unsigned char			gGPS_active = 0;
unsigned char			gGPS_data_valid = 0;						// 0:invalid, 1=valid
unsigned char			gGPS_sec;									// for b̃f[^ (BCD 0--59)
unsigned char			gGPS_min;									// for ̃f[^ (BCD 0--59)
unsigned char			gGPS_hou;									// for ̃f[^ (BCD 0--23j
unsigned char			gGPS_day;									// for ̃f[^ (BCD 1--31)
unsigned char			gGPS_mon;									// for ̃f[^ (BCD 1--12j
unsigned char			gGPS_year;									// for Ñf[^ (BCD 0--99)
unsigned char			gGPS_1sec_flag;								// for PbMɁ@nm
unsigned char			gGPS_rx_data_ari = 0;						// \p̂forMf[^Ă
unsigned char			gGPS_1sec_count = 0;						// forPbM̃JE^[
static	unsigned char	gGPS_rx_data[2][GPS_RX_NUMBER_MAX+2];		// forMf[^鏊
static	unsigned char	gGPS_rx_page = 0;							// forMf[^y[W
static	unsigned char	gGPS_rx_number = 0;							// forMf[^ԍ
static	unsigned char	gGPS_data_exist = 0;						// forMf[^L肩ۂ(0:NON, 1:page0, 2:page1)
static	unsigned char	temp_str[128];							// ėp̕鏊

// *********************************************************
// cF[̌
//  FN 
// @@ F
// @@ F
// ߂l@jFOjAPjADDDDUyj
// *********************************************************
unsigned char subZeller( unsigned short y, unsigned short m, unsigned short d )
{
	unsigned char	r;
	
    if( m < 3 ) {
        y--;
		m += 12;
    }
    r = (unsigned char)(( y + y/4 - y/100 + y/400 + ( 13*m + 8 )/5 + d )%7);
    return(r);
}


//*****************************************
// forv Initial
//  荞ݕs̏ԂŌĂ΂Ƃ
//
//*****************************************
void	gps_clock_init(void)
{
	unsigned char	uc;

// *********** RXD0 Bit ***********
	DDRD &= ~((1 << DDD0));		// Port-D Bit0 : Intput
	PORTD |= ((1 << PD0) );		// Port-D Bit0 : Pullup

// *********** TXD0 Bit ***********
	PORTD |= ((1 << PD1) );		// Port-D Bit1 : Hi
	DDRD |= (1 << DDD1);		// Port-D Bit1 : Output

	for(uc = 0; uc < GPS_RX_NUMBER_MAX+1; uc++){
		gGPS_rx_data[0][uc] = 0;	// forMf[^鏊
		gGPS_rx_data[1][uc] = 0;	// forMf[^鏊
		Ggps_data[uc] = 0;		// Mf[^ifobOpj
	}
	gGPS_rx_number = 0;			// forMf[^ԍ
	gGPS_rx_page = 0;			// forMf[^y[W
	gGPS_data_exist = 0;		// forMf[^L肩ۂ(0:NON, 1:page0, 2:page1)

	uart_init();				// UART0 ݒ
}

//***************************
// for PbMݐݒ
// GPS 1Sec sig intrrupt INT1
//***************************
void	gps_1sec_init(void)
{

	// INT1 Port Initial
	DDRD &= ~(1 << DDD3);		// Port-D Bit3 : Intput
	PORTD |= (1 << PD3);		// PD3 Pullup

	// INT1 Interrupt Initial
	EICRA |=  (1 << ISC11);		// INT1 Falling Edge Interrupt
	EICRA &= ~(1 << ISC10);		// INT1 Falling Edge Interrupt
	EIMSK |= (1 << INT1);		// INT1 Interrupt Enable

}
//*****************************************
// INT1 Interrupt
//  Start Bit Falling Edge Sence
// 	for PbM
//*****************************************
ISR (INT1_vect)
{
	gGPS_1sec_flag = 1;				// for PbMɁ@nm
	if(gGPS_1sec_count < 60){
		gGPS_1sec_count++;
	}
}

//*****************************************
//  iQj@abcQ̒l擾
//   cp: ̃|C^[
//  ߂l@擾abcf[^
//  		擾łȂ́@O
//*****************************************
unsigned char	get_BCD_from_str(unsigned char *cp)
{
	unsigned char	uc;
	unsigned char	d;

	uc = *(cp+0);
	if(('0' <= uc) && (uc <= '9')){			// ̎
		d = (uc & 0x0f);
		d <<= 4;
		uc = *(cp+1);
		if(('0' <= uc) && (uc <= '9')){
			d |= (uc & 0x0f);				// get BCD
		}else{
			d = 0xff;
		}
	}else{
		d = 0xff;
	}

	return(d);
}

//*****************************************
// w̃R}iڂj̎̕ÃR}̑O̕܂ł擾
//  cp; Tn߂镶̐擪
//   n: 
//
//  őłPQW܂ŒTB
//  OOOɂȂI
//  擾ł temp_str[128] ɓ
//  ߂l@PȏF擾ł
//  		OF擾łȂ
//*****************************************
unsigned char	get_commma_str(unsigned char *scp, unsigned char tn)
{
	unsigned char	r = 0;
	unsigned char	*tcp;
	unsigned char	n;
	unsigned char	i;
	
	for(n=0,i=0; i < 128; i++,scp++){
		if(*scp == 0x00){
			break;
		}else if(*scp == ','){
			n++;
			if(n == tn){
				break;
			}
		}
	}

	if(n == tn){					// w̃R}
		scp++;
		tcp = &temp_str[0];
		*tcp = 0x00;
		for(r=0 ; i<128;i++,scp++,tcp++,r++){
			if(*scp == 0x00){
				break;
			}else if(*scp == ','){
				break;
			}else{
				*tcp = *scp;
				*(tcp+1) = 0x00;
			}
		}
	}

	return(r);
}

//*****************************************
// forf[^NO[oϐɓ
//   forf[^ gGPS_rx_data[][]ɗL
//   ȉ̃O[oϐɓ
//	 gGPS_day;				for ̃f[^ (BCD 1--31)
//	 gGPS_mon;				for ̃f[^ (BCD 1--12j
//	 gGPS_year;				for Ñf[^ (BCD 0--99)
//   ߂l:@O=O[oϐɓĂȂAPforf[^O[oϐɓꂽ
//*****************************************
unsigned char	get_gps_data_ymd(unsigned char page)
{
	unsigned char	r = 0;
	unsigned char	uc;
	unsigned char	yd;
	unsigned char	md;
	unsigned char	dd;

	uc = get_commma_str(&gGPS_rx_data[page][0],9);		// Xڂ̃R}̎̕ÃR}̑O̕܂ł擾
	if(uc != 0){
		dd = get_BCD_from_str(&temp_str[0]);			//  abcQ̒l(j擾
		if(dd != 0xff){									// Ɏ擾ł
			md = get_BCD_from_str(&temp_str[2]);		//  abcQ̒l(j擾
			if(md != 0xff){								// Ɏ擾ł
				yd = get_BCD_from_str(&temp_str[4]);	//  abcQ̒l(Nj擾
				if(yd != 0xff){							// Ɏ擾ł
					gGPS_day  = dd;						// for ̃f[^ (BCD 1--31)
					gGPS_mon  = md;						// for ̃f[^ (BCD 1--12j
					gGPS_year = yd;						// for Ñf[^ (BCD 0--99)
					r = 1;
				}
			}
		}
	}

	return(r);
}
//*****************************************
// forf[^玞bO[oϐɓ
//   forf[^ gGPS_rx_data[][]ɗL
//   ȉ̃O[oϐɓ
//	 gGPS_sec;				for b̃f[^ (BCD 0--59)
//	 gGPS_min;				for ̃f[^ (BCD 0--59)
//	 gGPS_hou;				for ̃f[^ (BCD 0--23j
//   ߂l:@O=O[oϐɓĂȂAPforf[^O[oϐɓꂽ
//*****************************************
unsigned char	get_gps_data_hms(unsigned char page)
{
	unsigned char	r = 0;
	unsigned char	uc;
	unsigned char	hd;
	unsigned char	md;
	unsigned char	sd;

	uc = get_commma_str(&gGPS_rx_data[page][0],1);		// Pڂ̃R}̎̕ÃR}̑O̕܂ł擾
	if(uc != 0){
		hd = get_BCD_from_str(&temp_str[0]);			//  abcQ̒l(j擾
		if(hd != 0xff){									// Ɏ擾ł
			md = get_BCD_from_str(&temp_str[2]);		//  abcQ̒l(j擾
			if(md != 0xff){								// Ɏ擾ł
				sd = get_BCD_from_str(&temp_str[4]);	//  abcQ̒l(bj擾
				if(sd != 0xff){							// Ɏ擾ł
					gGPS_sec = sd;						// for b̃f[^ (BCD 0--59)
					gGPS_min = md;						// for ̃f[^ (BCD 0--59)
					gGPS_hou = hd;						// for ̃f[^ (BCD 0--23j
					r = 1;
				}
			}
		}
	}

	return(r);
}

//*****************************************
// forf[^̗LO[oϐɓ
//   forf[^ gGPS_rx_data[][]ɗL
//   ȉ̃O[oϐɓ
//   gGPS_data_valid;		forf[^̏ (0:invalid, 1=valid)
//   ߂l:@O=O[oϐɓĂȂAPforf[^O[oϐɓꂽ
//*****************************************
unsigned char	get_gps_data_valid(unsigned char page)
{
	unsigned char	r = 0;
	unsigned char	uc;

	uc = get_commma_str(&gGPS_rx_data[page][0],2);				// Qڂ̃R}̎̕ÃR}̑O̕܂ł擾
	if(uc != 0){
		if(temp_str[0] == 'A'){
			gGPS_data_valid = 1;
			r = 1;
		}
	}
	return(r);
}
//*****************************************
// Mf[^̃T`FbN
//  G[ɂ
//  EuvȂvif[^̏I܂ŒTj --> 1
//  EuvȂvif[^PQWȏł߂j --> 2
//  EMTl̕ --> 3
//  EMTlƌvZTlvȂ --> 4
//  EMTl̎̕bqAkełȂ --> 5
//  ߂l
//      G[FO
//      G[LFP||T
//*****************************************
unsigned char	sum_check_gps_data(unsigned char page)
{
	unsigned char	er = 0;
	unsigned char	i;
	unsigned char	uc;
	unsigned char	sum_data = 0;
	unsigned char	sum_gps;

	for(i=1; i < 128; i++){
		uc = gGPS_rx_data[page][i];
		if(uc == 0x00){					// ȂɃf[^I
			er = 1;
			break;
		}else if(uc == '*'){			// 
			break;
		}

		sum_data ^= uc;					// T
	}

	if(128 <= i){						// 128ŁȂ
		er = 2;
	}
	if(er == 0){						// 128Ł
											// ̒l߂
		uc = gGPS_rx_data[page][i+1];
		if(('A' <= uc)&& (uc <= 'F')){		// 'A' -- 'F' ̎
			uc = uc - 'A' + 10;
		}else if(('0' <= uc)&& (uc <= '9')){// '0' -- '9' ̎
			uc = uc - '0';
		}else{
			er = 3;
		}
	}

	if(er == 0){						// 128Łďʂ͐
		sum_gps = (uc * 16);			// ʂ̒l
										// ̒l߂
		uc = gGPS_rx_data[page][i+2];
		if(('A' <= uc)&& (uc <= 'F')){		// 'A' -- 'F' ̎
			uc = uc - 'A' + 10;
		}else if(('0' <= uc)&& (uc <= '9')){// '0' -- '9' ̎
			uc = uc - '0';
		}else{
			er = 3;
		}
	}

	if(er == 0){						// 128Łď㉺ʋɐ
		sum_gps += uc;					// ʂ𑫂ā@for痈T̒lɂȂ

		if(sum_data != sum_gps){		// ߂TƎMTĂ
			er = 4;
		}
	}

	if(er == 0){						// 128Łď㉺ʋɐŃTv
		if(gGPS_rx_data[page][i+3] != 0x0d){	// bq łȂ
			er = 5;
		}
		if(gGPS_rx_data[page][i+4] != 0x0a){	// kełȂ
			er = 5;
		}
	}

	return(er);
}

//*****************************************
// forvf[^擾iO[oϐɓj
//   ȉ̃O[oϐɓ
//	 gGPS_sec;				for b̃f[^ (BCD 0--59)
//	 gGPS_min;				for ̃f[^ (BCD 0--59)
//	 gGPS_hou;				for ̃f[^ (BCD 0--23j
//	 gGPS_day;				for ̃f[^ (BCD 1--31)
//	 gGPS_mon;				for ̃f[^ (BCD 1--12j
//	 gGPS_year;				for Ñf[^ (BCD 0--99)
//   gGPS_data_valid;		forf[^̏ (0:invalid, 1=valid)
//
//	gGPS_data_exist P͂Q̎ɂforf[^ƔfāA
//	̃f[^̒ANb̃f[^擾
//
//   ߂l:@O=Nb̃f[^擾ĂȂAPNb̃f[^擾
//*****************************************
unsigned char	get_gps_clock_data(void)
{
	unsigned char	r=0;
	unsigned char	rymd=0;
	unsigned char	rhms=0;
	unsigned char	rvalid=0;
	unsigned char	uc=0;
	unsigned char	er=0;
	unsigned char	page=0;


	if(gGPS_data_exist == 0){						// Mf[^
		r = 0;
	}else{											// Mf[^L
		er = sum_check_gps_data(page);				// Mf[^̃T`FbN
		if(er == 0){
			page = gGPS_data_exist-1;
			rhms = get_gps_data_hms(page);				// forf[^玞bO[oϐɓ
			rvalid = get_gps_data_valid(page);			// forf[^̗LO[oϐɓ
			rymd = get_gps_data_ymd(page);				// forf[^NO[oϐɓ

			if ((rymd == 1)||(rhms == 1)){				// ǂ炩̃f[^擾ł
				r = 1;
			}
		}

		if(gGPS_rx_data_ari == 0){						// fobOp̎Mf[^͎gIĂ
			for(uc=0;uc < GPS_RX_NUMBER_MAX+1; uc++){	// fobOpɎMf[^NA
				Ggps_data[uc] = 0x00;
			}
			for(uc=0;uc < gGPS_rx_number+1; uc++){		// fobOpɎMf[^
				Ggps_data[uc] = gGPS_rx_data[page][uc];
				if(Ggps_data[uc] == 0){
					break;
				}
			}

			Grymd[2]=rhms+'0';							// fobOpf[^NL
			Grhms[2]=rymd+'0';							// fobOpf[^bL
			Grvalid[2]=rvalid+'0';						// fobOpf[^L
			Gdata_page[2] = page+'0';					// fobOpf[^L(Page)
			Gdata_err[2] = er+'0';						// fobOpf[^G[(SUM Check)
			gGPS_rx_data_ari = 1;
		}

		gGPS_data_exist = 0;
	}

	return(r);
}
//*****************************************
// forf[^擾 荞݂ŌĂ΂iO[oϐɓj
//   @uc Mf[^
//   @er G[LiOFG[j
//   f[^́@gGPS_data_existPQɂ
//*****************************************
#define	WAIT_DOL	0
#define	WAIT_G		1
#define	WAIT_N		2
#define	WAIT_R		3
#define	WAIT_M		4
#define	WAIT_C		5
#define	WAIT_CR		6
#define	WAIT_LF		7

void	get_gps_data_for_intr(unsigned char uc, unsigned char er)
{
	static unsigned char	proc_stat = 0; // 0:wait'$', 1:wait'G', 2:wait'N', 3:wait'R', 4:wait'M', 5:wait'C', 6;wait 0x0d, 7;wait 0x0a, 8:get GPS data

	if(er != 0){									// G[L鎞
		proc_stat = WAIT_DOL;						// ŏ蒼
	}else{
		switch(proc_stat){
		 case WAIT_DOL:							// '$'
			if(uc == '$'){						// '$'̎
				gGPS_rx_number = 0;				// forMf[^ԍ
				gGPS_rx_data[gGPS_rx_page][gGPS_rx_number] = uc;
				gGPS_rx_number++;
				gGPS_rx_data[gGPS_rx_page][gGPS_rx_number] = 0;
				proc_stat = WAIT_G;
			}
			break;
		 case WAIT_G:							// 'G'
			if(uc == 'G'){						// 'G'̎
				gGPS_rx_data[gGPS_rx_page][gGPS_rx_number] = uc;
				gGPS_rx_number++;
				gGPS_rx_data[gGPS_rx_page][gGPS_rx_number] = 0;
					proc_stat = WAIT_N;
			}else{								// Ⴄ͓蒼
				proc_stat = WAIT_DOL;
			}
			break;
		 case WAIT_N:							// 'N'
			if((uc == 'P')||(uc == 'L')||(uc == 'A')||(uc == 'B')||(uc == 'Q')||(uc == 'N')){	// 'P','L','A','B','Q','N',̎
				gGPS_rx_data[gGPS_rx_page][gGPS_rx_number] = uc;
				gGPS_rx_number++;
				gGPS_rx_data[gGPS_rx_page][gGPS_rx_number] = 0;
				proc_stat = WAIT_R;
			}else{								// Ⴄ͓蒼
				proc_stat = WAIT_DOL;
			}
			break;
		 case WAIT_R:							// 'R'
			if(uc == 'R'){						// 'R'̎
				gGPS_rx_data[gGPS_rx_page][gGPS_rx_number] = uc;
				gGPS_rx_number++;
				gGPS_rx_data[gGPS_rx_page][gGPS_rx_number] = 0;
				proc_stat = WAIT_M;
			}else{								// Ⴄ͓蒼
				proc_stat = WAIT_DOL;
			}
			break;
		 case WAIT_M:							// 'M'
			if(uc == 'M'){						// 'M'̎
				gGPS_rx_data[gGPS_rx_page][gGPS_rx_number] = uc;
				gGPS_rx_number++;
				gGPS_rx_data[gGPS_rx_page][gGPS_rx_number] = 0;
				proc_stat = WAIT_C;
			}else{								// Ⴄ͓蒼
				proc_stat = WAIT_DOL;
			}
			break;
		 case WAIT_C:							// 'C'
			if(uc == 'C'){						// 'C'̎
				gGPS_rx_data[gGPS_rx_page][gGPS_rx_number] = uc;
				gGPS_rx_number++;
				gGPS_rx_data[gGPS_rx_page][gGPS_rx_number] = 0;
				proc_stat = WAIT_CR;
			}else{								// Ⴄ͓蒼
				proc_stat = WAIT_DOL;
			}
			break;
		 case WAIT_CR:							// CR(0x0d)
			gGPS_rx_data[gGPS_rx_page][gGPS_rx_number] = uc;
			gGPS_rx_number++;
			gGPS_rx_data[gGPS_rx_page][gGPS_rx_number] = 0;

			if( GPS_RX_NUMBER_MAX <= gGPS_rx_number ){	// őɒB
				proc_stat = WAIT_DOL;
				gGPS_data_exist = gGPS_rx_page + 1;		// ɂ
				gGPS_rx_page ^= 1;						// ̃y[Wɂ
			}else{
				if(uc == 0x0d){						// CR(0x0d)̎
					proc_stat = WAIT_LF;
				}
			}
			break;
		 case WAIT_LF:								// LF(0x0a)
			gGPS_rx_data[gGPS_rx_page][gGPS_rx_number] = uc;
			gGPS_rx_data[gGPS_rx_page][gGPS_rx_number+1] = 0;
			proc_stat = WAIT_DOL;
			gGPS_data_exist = gGPS_rx_page + 1;		// ɂ
			gGPS_rx_page ^= 1;						// ̃y[Wɂ
			break;
		 default:
			proc_stat = WAIT_DOL;
			break;
		}
	}
}

//*****************************************
// XԐi߂ifls{Ԃɂj
// ͈ȉɂ
//	gGPS_hou		̃f[^ (BCD 0--23)
//	gGPS_day		̃f[^ (BCD 1--31)
//	gGPS_mon		̃f[^ (BCD 1--12)
//	gGPS_year		Ñf[^ (BCD 0--99)
//*****************************************
void	clock_add_9hour(void)
{
	unsigned char	uru=0;
	unsigned char	syo=0;
	unsigned char	bin=0;
	unsigned char	ad=0;

	bin  = gGPS_year & 0x0f;
	bin += ((gGPS_year/16)*10);			// oCi[f[^
	if((bin % 4) == 0){					// 邤N
		uru=1;
	}
	if((gGPS_mon == 0x04)||(gGPS_mon == 0x06)||(gGPS_mon == 0x09)||(gGPS_mon == 0x11)){	// ̌
		syo=1;
	}

//  hour
	bin  = gGPS_hou & 0x0f;
	bin += ((gGPS_hou/16)*10);			// oCi[f[^
	bin += 9;
	if(bin <= 23){
		ad = 0;
	}else{
		bin -= 24;
		ad = 1;
	}
	gGPS_hou = (bin/10);
	gGPS_hou <<= 4;
	gGPS_hou += (bin%10);

	if(ad == 1){
//  day
		bin  = gGPS_day & 0x0f;
		bin += ((gGPS_day/16)*10);			// oCi[f[^
		bin++;
		if(syo == 1){						// ̌
			if(bin <= 30){
				ad = 0;
			}else{
				bin -= 30;
				ad = 1;
			}
		}else if(gGPS_mon == 0x02){			// Q
			if(uru == 1){					// 邤N
				if(bin <= 29){
					ad = 0;
				}else{
					bin -= 29;
					ad = 1;
				}
			}else{							// Q N
				if(bin <= 28){
					ad = 0;
				}else{
					bin -= 28;
					ad = 1;
				}
			}
		}else{								// ̌
			if(bin <= 31){
				ad = 0;
			}else{
				bin -= 31;
				ad = 1;
			}
		}
		gGPS_day = (bin/10);
		gGPS_day <<= 4;
		gGPS_day += (bin%10);
	}

	if(ad == 1){
//  month
		bin  = gGPS_mon & 0x0f;
		bin += ((gGPS_mon/16)*10);			// oCi[f[^
		bin++;
		if(bin <= 12){
			ad = 0;
		}else{
			bin -= 12;
			ad = 1;
		}
		gGPS_mon = (bin/10);
		gGPS_mon <<= 4;
		gGPS_mon += (bin%10);
	}

	if(ad == 1){
// N year
		bin  = gGPS_year & 0x0f;
		bin += ((gGPS_year/16)*10);			// oCi[f[^
		bin++;
		if(bin <= 99){
			ad = 0;
		}else{
			bin -= 100;
		}
		gGPS_year = (bin/10);
		gGPS_year <<= 4;
		gGPS_year += (bin%10);
	}
}
