//*****************************************
// AVR ATmega328 8x8 LED Clock
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:infrared.c
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/01 Modify for pr_mega1284_8x8dot_clock Taishi
//  2022/10/10 add day_of_week Display Taishi
//  2023/02/01 Modify for pr_mega328_8x8dot_clock Taishi
//*****************************************
#include	<avr/io.h>

#include	"pr_mega328_8x8dot_clock_h.h"
#include	"timer_h.h"
#include	"uart_h.h"
#include	"infrared_h.h"


unsigned short	Ginf_data;					// Mf[^ifobOpj
unsigned char	gir_bit;					// ԊÕrbgf[^
unsigned short	g600bps_1bit = 13333;		// 1bit Time of 600BPS
unsigned short	g600bps_start = 6666;		// Startbit Time of 600BPS(1bit time /2)

//*****************************************
// ԊORfq Initial
//  荞ݕs̏ԂŌĂ΂Ƃ
//  oaOɐM
//  \tgłt`qŝłshldqPg
//*****************************************
void	infrared_init(void)
{
	DDRB &= ~((1 << DDB0));		// Port-B Bit0 : Intput
	PORTB |= ((1 << PB0) );		// Port-B Bit0 : Pullup

	g600bps_1bit = gBPS_600 * 16;		// 1bit Time of 600BPS
	g600bps_start = gBPS_600 * 8;		// Startbit Time of 600BPS(1bit time /2)

	timer1_init_600bps();		// Timer1 Initial for 600BPS
}
//***************************
//  ԊORfqԂ
//   ocOFk   M ߂lP
//   ocOFg MȂ ߂lO
//***************************
unsigned char	get_infrared_stat(void)
{
	unsigned char	r = 0;

	if((PINB & (1 << PINB0)) == 0){			//ԊORfqԂ擾
		r = 1;
	}

	return(r);
}

//***************************
// ԊORfqWrbgf[^擾
//   uc: Mf[^鏊
// ߂l  : 0=Mf[^
//         : 1=Mf[^L
//***************************
// MrbgԁiWrbgf[^j
enum INFR_CHAR {
		INFC_CHAR_START = '0',

		INFC_INIT,				// X^[grbgO g ҂
		INFC_STR_D_W,			// X^[grbg  ҂
		INFC_STR_L_W,			// X^[grbg kmF ҂
		INFC_BIT0_W,			// Orbgڂ 擾҂
		INFC_BIT1_W,			// Prbgڂ 擾҂
		INFC_BIT2_W,			// Qrbgڂ 擾҂
		INFC_BIT3_W,			// Rrbgڂ 擾҂
		INFC_BIT4_W,			// Srbgڂ 擾҂
		INFC_BIT5_W,			// Trbgڂ 擾҂
		INFC_BIT6_W,			// Urbgڂ 擾҂
		INFC_BIT7_W,			// Vrbgڂ 擾҂
		INFC_STOP_W,			// Xgbvrbǵ@gmF ҂

		INFC_CHAR_END,
	};

static
unsigned char	get_infrared_char(unsigned char *uc)
{
	unsigned char	r = 0;
	static	unsigned char	bit_st = INFC_INIT;	// INFR_CHAR ̒l
	static	unsigned char	char_data= 0;		// Mf[^

	switch(bit_st){
	 case INFC_INIT:
		if((IR_PORT & IR_BIT) != 0){
			bit_st = INFC_STR_D_W;
		}
		break;
	 case INFC_STR_D_W:
		if((IR_PORT & IR_BIT) == 0){
			gflg_tm1_timeup = 0;
			TCNT1 = 0;																				// Timer1 Count Set to ZERO
			OCR1A = g600bps_start;																	// ^C}[lZbg
			TIMSK1 |= (1 << OCIE1A);																// A Comper Match Interrupt Enable
			TCCR1B = ( (0 << WGM13) | (1 << WGM12) | (0 << CS12) | (0 << CS11) | (1 << CS10) );		// bsb 1/1A^C}[  X^[g
			bit_st = INFC_STR_L_W;
		}
		break;
	 case INFC_STR_L_W:							// X^[grbg
		if(gflg_tm1_timeup != 0){
			gflg_tm1_timeup = 0;
			if(gir_bit == 0){
				OCR1A = g600bps_1bit;			// ^C}[lZbg
				bit_st = INFC_BIT0_W;
				char_data= 0;					// Mf[^ NA
			}else{
				TCCR1B = 0x00;					// ^C}[  Xgbv
				TIMSK1 &= ~(1 << OCIE1A);		// A Comper Match Interrupt Disable
				bit_st = INFC_INIT;
			}
		}
		break;

	 case INFC_BIT0_W:							// Orbg
		if(gflg_tm1_timeup != 0){
			gflg_tm1_timeup = 0;
			if(gir_bit != 0){
				char_data |= 0x01;				// Mf[^Ɍ݂̃rbg
			}
			bit_st = INFC_BIT1_W;
		}
		break;
	 case INFC_BIT1_W:							// Prbg
		if(gflg_tm1_timeup != 0){
			gflg_tm1_timeup = 0;
			if(gir_bit != 0){
				char_data |= 0x02;				// Mf[^Ɍ݂̃rbg
			}
			bit_st = INFC_BIT2_W;
		}
		break;
	 case INFC_BIT2_W:							// Qrbg
		if(gflg_tm1_timeup != 0){
			gflg_tm1_timeup = 0;
			if(gir_bit != 0){
				char_data |= 0x04;				// Mf[^Ɍ݂̃rbg
			}
			bit_st = INFC_BIT3_W;
		}
		break;
	 case INFC_BIT3_W:							// Rrbg
		if(gflg_tm1_timeup != 0){
			gflg_tm1_timeup = 0;
			if(gir_bit != 0){
				char_data |= 0x08;				// Mf[^Ɍ݂̃rbg
			}
			bit_st = INFC_BIT4_W;
		}
		break;
	 case INFC_BIT4_W:							// Srbg
		if(gflg_tm1_timeup != 0){
			gflg_tm1_timeup = 0;
			if(gir_bit != 0){
				char_data |= 0x10;				// Mf[^Ɍ݂̃rbg
			}
			bit_st = INFC_BIT5_W;
		}
		break;
	 case INFC_BIT5_W:							// Trbg
		if(gflg_tm1_timeup != 0){
			gflg_tm1_timeup = 0;
			if(gir_bit != 0){
				char_data |= 0x20;				// Mf[^Ɍ݂̃rbg
			}
			bit_st = INFC_BIT6_W;
		}
		break;
	 case INFC_BIT6_W:							// Urbg
		if(gflg_tm1_timeup != 0){
			gflg_tm1_timeup = 0;
			if(gir_bit != 0){
				char_data |= 0x40;				// Mf[^Ɍ݂̃rbg
			}
			bit_st = INFC_BIT7_W;
		}
		break;
	 case INFC_BIT7_W:							// Vrbg
		if(gflg_tm1_timeup != 0){
			gflg_tm1_timeup = 0;
			if(gir_bit != 0){
				char_data |= 0x80;				// Mf[^Ɍ݂̃rbg
			}
			bit_st = INFC_STOP_W;
		}
		break;
	 case INFC_STOP_W:							// Xgbvrbg
		if(gflg_tm1_timeup != 0){
			TCCR1B = 0x00;						// ^C}[  Xgbv
			TIMSK1 &= ~(1 << OCIE1A);			// A Comper Match Interrupt Disable
			gflg_tm1_timeup = 0;
			if(gir_bit != 0){					// XgbvrbgL
				*uc = char_data;				// Mf[^i[
				r = 1;							// Mf[^Lɂ
			}
			bit_st = INFC_INIT;
		}
		break;

	 default:								// ̑̑҂iւ͗Ȃj
		bit_st = INFC_INIT;
		break;
	}
	return(r);
}


//***************************
//  ԊORfqf[^
//    VAʐMf[^ 's',data1,data2, 'e' ̂Sf[^Ƃ
//    Yf[^ȊOM͍܂ł̃f[^jAX^[gf[^҂ɂȂ
//   ߂l
//		OOO			f[^
//		IND1_ON_NOW			set n߂	'1'
//		IND1_ON_CONTINUE	set A		'2'
//		IND1_OFF_SHORT		set Z		'3'
//		IND1_OFF_LONG		set 		'4'
//		IND2_ON_NOW			select n߂	'5'
//		IND2_ON_CONTINUE	select A		'6'
//		IND2_OFF_SHORT		select Z	'7'
//		IND2_OFF_LONG		select 	'8'
//***************************
enum WAIT_STATE {			// f[^҂[h
		WAIT_START_D = 0,	// X^[gf[^҂
		WAIT_DATA1,			// P҂
		WAIT_DATA2,			// Q҂
		WAIT_END_D,			// Ghf[^҂
	};
#define	START_D	's'
#define	END_D	'e'

unsigned char	get_infrared_data(void)
{
	unsigned char			r = 0;
	static unsigned char	st = WAIT_START_D;
	static unsigned char	uc = 0;
	static unsigned char	inf_data[5] = {0,0,0,0,0};

	r = get_infrared_char(&uc);					// Wrbgf[^擾

	if(r != 0){									// Mf[^L
		Ginf_data = uc;							// fobOpf[^ɓ
		tim_10ms_infrared = 10;					// kdc_
		r = 0;
		switch(st){
		 case WAIT_START_D:						// X^[gf[^҂
			if(uc == START_D){					//  X^[gf[^̎
				inf_data[0] = uc;
				st = WAIT_DATA1;
			}
			break;
		 case WAIT_DATA1:						// f[^P҂
			if((INFR_DATA_START < uc) && (uc < INFR_DATA_END)){	//  f[^P͈͓̔̎
				inf_data[1] = uc;				//   f[^Pۑ
				st = WAIT_DATA2;				//   f[^Q҂ɂ
			}else{								//  ͈͊O̎
				st = WAIT_START_D;				//   X^[gf[^҂ɖ߂
			}
			break;
		 case WAIT_DATA2:						// f[^Q҂
			if((INFR_DATA_START < uc) && (uc < INFR_DATA_END)){	//  f[^Q͈͓̔̎
				inf_data[2] = uc;				//   f[^Qۑ
				st = WAIT_END_D;				//   Ghf[^҂ɂ
			}else{								//  ͈͊O̎
				st = WAIT_START_D;				//   X^[gf[^҂ɖ߂
			}
			break;
		 case WAIT_END_D:						// Ghf[^҂
			if(uc == END_D){					//  Ghf[^̎
				inf_data[3] = uc;
				st = WAIT_START_D;
				if(inf_data[1] == inf_data[2]){	//  f[^PƂQ
					r = inf_data[1];			//   ߂lZbg
				}
			}else{								//  Ghf[^ȊO̎
				st = WAIT_START_D;				//   X^[gf[^҂ɖ߂
			}
			break;
		 default:								// ̑̑҂iւ͗Ȃj
			st = WAIT_START_D;
			break;
		}
	}

	return(r);
}

