//*****************************************
// AVR ATmega328 8x8 LED Clock
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:pr_mega328_8x8dot_clocl.c
//@ pro_fifteen_in17_clock ̃vWFNgRs[ā@pro_fourteen_in172_clock@ɂ킹B
//
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/01 Modify for pr_mega1284_8x8dot_clock Taishi
//  2022/10/10 add day_of_week Display Taishi
//  2023/02/01 Modify for pr_mega328_8x8dot_clock Taishi
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"pr_mega328_8x8dot_clock_h.h"
#include	"timer_h.h"
#include	"port_bit_h.h"
#include	"display_h.h"
#include	"dot8x8_h.h"
#include	"eep_dat_h.h"
#include	"uart_h.h"
#include	"infrared_h.h"
#include	"gps_clock_h.h"
#include	"OLED_1306_h.h"
#include	"setting_h.h"
#include	"ad_conv_h.h"

unsigned char			g_keta;
unsigned char			Ggps_data_ari[4] = {'D',':','0',0};					// fobOpforf[^
unsigned char			gDISP_sec_mode = 1;									// b\ 0:Ȃ , 1:l , 2:_ , 3:o[

static	unsigned char	run=0;

//***************************
// SQiimax 9999)AXL[Sɂ
//   ϊAXL[ ɓ
//***************************
void	set_binary_4(unsigned char *bf, unsigned short us)
{
	*(bf+0) = '0' + (us/1000);			// 
	*(bf+1) = '0' + ((us%1000)/100);	// 2
	*(bf+2) = '0' + ((us%100)/10);		// 3
	*(bf+3) = '0' + (us%10);			// 
	*(bf+4) = 0x00;

}
//***************************
//  9600BPS̃JE^[ \ (OLED)
//***************************
void	oled_disp_bps9600(void)
{
	unsigned char	ucbf[10];

	ucbf[0] = '9';
	ucbf[1] = '6';
	ucbf[2] = '0';
	ucbf[3] = '0';
	ucbf[4] = ':';
	set_binary_4(&(ucbf[5]), gBPS_9600);			// SQiimax 9999)AXL[Sɂ
	disp_oled_G_12x16(0*6, 3*8, ucbf);				// x:0, y:3, 9600
}

//***************************
//  QîS\(max 9999) (OLED)
//***************************
void	oled_disp_binary(unsigned char x, unsigned char y, unsigned short us)
{
	unsigned char	ucbf[10];

	if(9999 < us){
		us = 9999;
	}
	set_binary_4(&(ucbf[0]), us);			// SQiimax 9999)AXL[Sɂ
	disp_oled_G(x, y, ucbf);				// x:0, y:1, 600bps
}

//***************************
//  600BPS̃JE^[ \ (OLED)
//***************************
void	oled_disp_bps600(void)
{
	unsigned char	ucbf[10];

	ucbf[0] = ' ';
	ucbf[1] = '6';
	ucbf[2] = '0';
	ucbf[3] = '0';
	ucbf[4] = ':';
	set_binary_4(&(ucbf[5]), gBPS_600);				// SQiimax 9999)AXL[Sɂ
	disp_oled_G_12x16(0*6, 1*8, ucbf);				// x:0, y:1, 600bps
}

//***************************
//  Version \ (OLED)
//***************************
void	oled_disp_version(void)
{
	unsigned char	ucbf[7];

	ucbf[0] = ' ';
	set_binary_4(&(ucbf[1]), VER_DATA);			// SQiimax 9999)AXL[Sɂ
	ucbf[6] = ucbf[5];
	ucbf[5] = ucbf[4];
	ucbf[4] = ucbf[3];
	ucbf[3] = '.';

	if(ucbf[1] == '0'){
		ucbf[1] = 'V';
	}else{
		ucbf[0] = 'V';
	}
	disp_oled_G_12x16(4*6, 6*8, ucbf);							// x:4, y:6, Version
}

//***************************
//  Title & Version \ (OLED)
//***************************
void	oled_disp_title_and_version(void)
{

	disp_oled_G_12x16(4*6, 0*8, (unsigned char *)"Mega328");	// x:4, y:1, "mega328 8x8dot clock"
	disp_oled_G_12x16(5*6, 2*8, (unsigned char *)"8x8dot");		// x:5, y:2, "mega328 8x8dot clock"
	disp_oled_G_12x16(6*6, 4*8, (unsigned char *)"Clock");		// x:6, y:4, "mega328 8x8dot clock"

	oled_disp_version();						//  Version \ (OLED)
}

//***************************
// Qabcimax 99)AXL[Qɂ
//***************************
void	set_bcd_2(unsigned char *bf, unsigned char uc)
{
	unsigned char	nh;
	unsigned char	nl;

	nh = uc;
	nh >>= 4;
	nl = uc;
	nl &= 0x0f;

	if((0 <= nh) && ( nh <= 9)){			// lȎ
		*(bf+0) = (nh + '0');
	}else{
		*(bf+0) = (nh + 'A');
	}

	if((0 <= nl) && ( nl <= 9)){			// lȎ
		*(bf+1) = (nl + '0');
	}else{
		*(bf+1) = (nl + 'A');
	}

	*(bf+2) = 0x00;

}
//***************************
//  abc N\ (OLED)
//***************************
void	oled_disp_year(void)
{
	unsigned char	ucbf[7];

	ucbf[0] = '2';
	ucbf[1] = '0';
	set_bcd_2(&(ucbf[2]), gGPS_year);			// NQabcimax 99)AXL[Qɂ
	disp_oled_G_12x16(0*6, 0*8, ucbf);			// x:0, y:0, N
}

//***************************
//  abc \ (OLED)
//***************************
void	oled_disp_mon_day(void)
{
	unsigned char	ucbf[7];

	set_bcd_2(&(ucbf[0]), gGPS_mon);			// Qabcimax 99)AXL[Qɂ
	ucbf[2] = '-';
	set_bcd_2(&(ucbf[3]), gGPS_day);			// Qabcimax 99)AXL[Qɂ
	disp_oled_G_12x16(11*6, 0*8, ucbf);			// x:11, y:0, 
}

//***************************
//  abc \ (OLED)
//***************************
void	oled_disp_hou_min(void)
{
	unsigned char	ucbf[7];

	set_bcd_2(&(ucbf[0]), gGPS_hou);			// Qabcimax 99)AXL[Qɂ
	ucbf[2] = ':';
	set_bcd_2(&(ucbf[3]), gGPS_min);			// Qabcimax 99)AXL[Qɂ
	disp_oled_G_24x32(0*6, 2*8, ucbf);			// x:0, y:2, 
}

//***************************
//  abc b\ (OLED)
//***************************
void	oled_disp_sec(void)
{
	unsigned char	ucbf[7];

	set_bcd_2(&(ucbf[0]), gGPS_sec);			// bQabcimax 99)AXL[Qɂ
	disp_oled_G_12x16(16*6, 6*8, ucbf);			// x:16, y:6, b
}

//***************************
// b L_ŕ\
//  uc:O@
//  uc:P@_
//***************************
void	disp_sec_blink(unsigned char uc)
{
	if(uc == 1){
		disp_one_char_oled_G(18*6, 7*8, '*');
	}else{
		disp_one_char_oled_G(18*6, 7*8, ' ');
	}
}

//***************************
// o[pڐ\
//***************************
void	disp_sec_bar_scale(void)
{
	disp_hline_oled_G(  0,  3, 6*8);	//  0sec display OLED N H-Line
	disp_hline_oled_G( 30, 31, 6*8);	// 15sec display OLED N H-Line
	disp_hline_oled_G( 60, 62, 6*8);	// 30sec display OLED N H-Line
	disp_hline_oled_G( 90, 91, 6*8);	// 45sec display OLED N H-Line
	disp_hline_oled_G(118,121, 6*8);	// 60sec display OLED N H-Line
}
//***************************
// b o[\
//***************************
void	disp_sec_bar(unsigned char n, unsigned char	bcd_data)
{
	static	unsigned char	old_n = 0;

	if(bcd_data == 1){
		n = ((n >> 4)*10 + (n &0x0f));
	}
	if(n == 0){
		old_n = 0;
		disp_line_clear_oled_G(7*8);		// Clear
		disp_hline_oled_G(  0,  3, 7*8);	//  0sec display OLED N H-Line
		disp_hline_oled_G( 30, 31, 7*8);	// 15sec display OLED N H-Line
		disp_hline_oled_G( 60, 62, 7*8);	// 30sec display OLED N H-Line
		disp_hline_oled_G( 90, 91, 7*8);	// 45sec display OLED N H-Line
		disp_hline_oled_G(118,121, 7*8);	// 60sec display OLED N H-Line
	}else{
		if(n <= 60){
			n *= 2;
			disp_hline_oled_G(old_n, n, 7*8);	// display OLED N H-Line
			old_n = n;
		}
	}
}

//***************************
// fobOpforMf[^̕\
//  QOWs\@Vsgp
//	Ggps_data[] ɎMf[^iőPQOj
//***************************
void	disp_gps_rx_data(void)
{
	unsigned char	uc;
	unsigned char	line;

	// Line 0 --> 6
	for(line=0;line < 7;line++){
		if(Ggps_data[line*20] == 0){							// ̍sɂ̓f[^
			disp_line_clear_oled_G(line * 8);					// One Line Clear Display
		}else{													// ̍sɂ̓f[^L鎞
			uc = Ggps_data[line*20+20];							// ̍s̉E[̃f[^
			if(uc == 0){										// ̒l^[~l[^Ȃ̂ŁA̍s̓rŃf[^͏I
				disp_line_clear_oled_G(line * 8);				// One Line Clear Display
				disp_oled_G(0, line * 8, Ggps_data+(line*20));	// display OLED(20char x 8Line)
			}else{
				Ggps_data[line*20+20] = 0;
				disp_oled_G(0, line * 8, Ggps_data+(line*20));	// display OLED(20char x 8Line)
				Ggps_data[line*20+20] = uc;
			}
		}
	}

	// line 7
//	disp_line_clear_oled_G(7 * 8);								// One Line Clear Display
//	disp_oled_G(0, 7 * 8, Ggps_data+120);						// display OLED(20char x 8Line)

	disp_oled_G(9*6, 7*8, Grymd);								// fobOpf[^NL
	disp_oled_G(13*6, 7*8, Grhms);								// fobOpf[^bL
	disp_oled_G(17*6, 7*8, Grvalid);							// fobOpf[^L
	disp_oled_G(5*6, 7*8, Gdata_page);							// fobOpf[^y[W
	disp_oled_G(1*6, 7*8, Gdata_err);							// fobOpf[^G[
	Grymd[2]=' ';												// fobOpf[^NL
	Grhms[2]=' ';												// fobOpf[^bL
	Grvalid[2]=' ';												// fobOpf[^L
	Gdata_page[2]=' ';											// fobOpf[^y[W
	Gdata_err[2]=' ';											// fobOpf[^G[

}

//***************************
// `FbNiX^eBbN\js
//  kdcPRx_ł
//  e̐\Ă鎞 XCb`閈ɂO`XԂɕ\
//  XCb` \錅ړB ԍ珇ԂŁAŌオŘŁA͈ԍɖ߂
//***************************
void	check_static(void)
{
	unsigned short	us;
	unsigned char	kazu = 0;
	unsigned char	keta = 4;						// 20221010
	unsigned char	req_disp = 0;
	unsigned char	old_keta = 1;

	led5_on();										// LED1 ON
	delay_ms(500);									// 500mS Delay
	led5_off();										// LED1 OFF
	delay_ms(500);									// 500mS Delay
	led5_on();										// LED1 ON
	delay_ms(500);									// 500mS Delay
	led5_off();										// LED1 OFF
	delay_ms(500);									// 500mS Delay
	led5_on();										// LED1 ON
	wait_sw_off();									// XCb`@܂ŉiv[v
	led5_off();										// LED1 OFF

	get_sw();

	sei();											// 荞݉
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay

//	keta = 5;
	keta = 4;										// 20221010
	kazu = 0;
	disp_dot8x8_number(keta+1, 15);					// 
	disp_dot8x8_number(keta+2, 15);					// 
	disp_dot8x8_number(keta+3, 15);					// 
	disp_dot8x8_number(keta+4, 15);					// 
	disp_dot8x8_number(keta+5, 15);					// 20221010 

	disp_dot8x8_number(keta, kazu);					// 
	old_keta = keta;
	led5_off();										// LED1 OFF
	req_disp = 1;									// \vnm

	for(;;){
		if(req_disp == 1){										// \vnm̎
			disp_dot8x8_all();									// WW S\
			req_disp = 0;										// \vnee
		}

		us = get_action_sw();									// XCb`Ԃ
		us &= SW_MASK;											// XCb`ɂ

		if((us == SW2_OFF_SHORT)||(us == SW2_OFF_LONG)){		// XCb`NbNꂽ(select switch)
			kazu++;
			if(9 < kazu){
				kazu = 0;
			}
			disp_dot8x8_number(keta, kazu);						// 
			req_disp = 1;										// \vnm
		}

		if((us == SW1_OFF_SHORT)||(us == SW1_OFF_LONG)){		// XCb`NbNꂽ(set switch)
			keta++;
			if(KETA_MAX <= keta){
//				keta = 5;
				keta = 4;										// 20221010
			}
			disp_dot8x8_number(old_keta, 15);					// Ǒ̐
			disp_dot8x8_number(keta, kazu);						// 
			old_keta = keta;
			req_disp = 1;										// \vnm
		}
	}

}
//***************************
// `FbNi_Ci~bN\js
//  kdcPAQQx_ł
//  XCb`ėꂽ eO`XAĕ\iPbԊuŕ\ωj
//***************************
void	check_dynamic(void)
{
	unsigned short	us;
	unsigned char	old_run = 0;
	unsigned char	kazu = 0;
	unsigned char	keta = 4;						// 20221010
	unsigned char	old_keta = 1;
	unsigned char	pause = 0;
	unsigned char	req_disp = 0;

	led5_on();										// LED1 ON
	delay_ms(500);									// 500mS Delay
	led5_off();										// LED1 OFF
	delay_ms(500);									// 500mS Delay
	led5_on();										// LED1 ON
	wait_sw_off();									// XCb`@܂ŉiv[v
	led5_off();										// LED1 OFF

	get_sw();

	tim_10ms_blink = 0;								// uNp^C}[𗬗p
	old_run = run;
	sei();											// 荞݉
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay

	led5_off();										// LED1 OFF
	disp_dot8x8_clear();							// \S 
	req_disp = 1;									// \vnm

	for(;;){
		if(req_disp == 1){										// \vnm̎
			disp_dot8x8_all();									// WW S\
			req_disp = 0;										// \vnee
		}

		us = get_action_sw();									// XCb`Ԃ
		us &= SW_MASK;											// XCb`ɂ

		if(us == SW2_OFF_SHORT){								// XCb`Zėꂽ(select switch)
			pause ^= 1;											// ړ\𒆒f or Jn
		}

		if(tim_10ms_blink == 0){
			tim_10ms_blink = 100;								// 1000mS Ԋu
			if(pause == 0){
				if(old_keta != keta){							// ς
					disp_dot8x8_number(old_keta, 15);			// Ǒ̐
					old_keta = keta;
					req_disp = 1;								// \vnm
				}
				disp_dot8x8_number(keta, kazu);					// 
				req_disp = 1;									// \vnm

				kazu++;
				if(9 < kazu){									// \XȏɂȂ
					kazu = 0;									// Oɖ߂
					keta++;
					if(KETA_MAX <= keta){						// \߂
//						keta = 5;
						keta = 4;								// 20221010
					}
				}
			}
		}
	}

}


//***************************
// Aj[V\
//@ODPbɌĂ΂
// 
//@FP̂
// ߂l
//@OAj[Vr
//@PAj[VI
//***************************
unsigned char	disp_animation(unsigned char init)
{
	static	unsigned char	ani_keta = 4;		// 20221010  4--9
	static	unsigned char	ani_kazu = 0;		// l 0--9
	unsigned char			r = 0;

	if (init == 1){
		ani_keta = 4;							// 20221010
		ani_kazu = 0;
	}else{
		if(ani_kazu == 0){
			disp_dot8x8_number(4, 15);					// 20221010 
			disp_dot8x8_number(5, 15);					// 
			disp_dot8x8_number(6, 15);					// 
			disp_dot8x8_number(7, 15);					// 
			disp_dot8x8_number(8, 15);					// 
			disp_dot8x8_number(9, 15);					// 
			ani_kazu = 0;
		}

		disp_dot8x8_number(ani_keta, ani_kazu);
		disp_dot8x8_all();									// WW S\

		ani_kazu++;
		if(9 < ani_kazu){
			ani_kazu = 0;
			ani_keta++;										// ̌
			if(9 < ani_keta){
				ani_keta = 4;								// 20221010
				r = 1;
			}
		}
	}

	return(r);
}

//***************************
// ԊORf[^XCb`f[^ɕϊ
//***************************
unsigned short	trans_if_to_sw(unsigned char if_data)
{
	unsigned short	us = 0;
	static unsigned short	sw_stat = 0;

	switch(if_data){
	 case IND1_ON_NOW:			// set n߂
		us = SW1_ON_NOW;
		sw_stat |= SW1_ON;
		break;
	 case IND1_ON_CONTINUE:		// set A
		us = SW1_ON_CONTINUE;
		break;
	 case IND1_OFF_SHORT:		// set Zė
		us = SW1_OFF_SHORT;
		sw_stat &= ~(SW1_ON);
		break;
	 case IND1_OFF_LONG:		// set ė
		us = SW1_OFF_LONG;
		sw_stat &= ~(SW1_ON);
		break;
	 case IND2_ON_NOW:			// select n߂
		us = SW2_ON_NOW;
		sw_stat |= SW2_ON;
		break;
	 case IND2_ON_CONTINUE:		// select A
		us = SW2_ON_CONTINUE;
		break;
	 case IND2_OFF_SHORT:		// select Zė
		us = SW2_OFF_SHORT;
		sw_stat &= ~(SW2_ON);
		break;
	 case IND2_OFF_LONG:		// select ė
		us = SW2_OFF_LONG;
		sw_stat &= ~(SW2_ON);
		break;
	}

	us |= sw_stat;
	return(us);
}


//***************************
//  Uij{S{Rj p Main
//   forf[^g
//***************************
static	void	main_6_keta_gps(void)
{
	unsigned short	us;
	unsigned char	ucinf;
	unsigned char	disp_clock_mode=HM;
	unsigned char	old_disp_clock_mode=HM;
	unsigned char	old_GPS_sec = 0xff;
	unsigned char	old_GPS_min = 0xff;
	unsigned char	old_GPS_hou = 0xff;
	unsigned char	old_GPS_mon = 0xff;
	unsigned char	old_GPS_day = 0xff;
	unsigned char	old_GPS_year = 0xff;
	unsigned char	req_disp = 0;					// \v
	unsigned char	gps_data_ari = 0;
	unsigned char	gps_wday = 0;					// j(0-->6)
	unsigned char	exist_gps = 0;					// forL (0: ,1:L)
	unsigned char	disp_gps_moji = 0;
	unsigned char	req_gps_data_set = 0;
	unsigned char	req_disp_year = 0;
	unsigned char	req_disp_mon_day = 0;
	unsigned char	req_disp_hou_min = 0;
	unsigned char	req_disp_sec = 0;
	unsigned char	disp_gps_rx_data_req = 0;
	unsigned char	dark = 0;

	gps_clock_init();								// forv Initial
	gps_1sec_init();								// for PbMݐݒ
	infrared_init();								// ԊORfq Initial

	led5_on();										// red LED ON

	ad6_init();										// A/D 6 Initial
	dark_sig_off();									// Dark signal OFF

	uart_pause();									// UART0 ̎擾߂

	sei();											// 荞݉

	disp_dot8x8_number(4, 15);						// 
	disp_dot8x8_4binary(6,VER_DATA);				// o[WS\iXXXX܂Łj
	if(VER_DATA/1000 == 0){
		disp_dot8x8_number(5, 15);					// 
		disp_dot8x8_moji(6, 'V');
	}
	disp_dot8x8_all();								// WW S\

	delay_ms(2000);									// 2000mS Delay
	led5_off();										// red LED OFF

	disp_dot8x8_moji(5,'B');						// 
	disp_dot8x8_4binary(6,gBPS_600);				// aorUOO@S\iXXXX܂Łj
	disp_dot8x8_all();								// WW S\

	for(ucinf = 0;ucinf <= 5; ucinf++){
		disp_line_clear_oled_G(ucinf * 8);			// One Line Clear Display
	}
	oled_disp_bps600();								//  600BPS̃JE^[ \ (OLED)
	oled_disp_bps9600();							//  9600BPS̃JE^[ \ (OLED)

	delay_ms(2000);									// 2000mS Delay

	disp_dot8x8_moji(5,'b');						// 
	disp_dot8x8_4binary(6,gBPS_9600);				// aorXUOO@S\iXXXX܂Łj
	disp_dot8x8_all();								// WW S\

	delay_ms(2000);									// 2000mS Delay

	disp_clear_oled_G();							// Clear All OLED Display

	tim_10ms_anime = 100;

	exist_gps = 0;									// forƂ
	tim_1s_no_gps = 0;								// forf[^̗P\^CAbvp 60sec
	tim_10ms_blink = 50;
	disp_gps_moji = 0;
	req_disp = 0;									// \vnm
	ucinf = 0;

// Debug Signal -------------
	debsig_init();
// ---------------------------

	if(gDISP_sec_mode == 3){						// b̉o[\
		disp_sec_bar_scale();						// o[pڐ\
	}

	if(gDISP_sec_mode != 3){
		disp_oled_G(0*6, 7*8, (unsigned char *)"A/D:");	// x:0, y:7, "A/D:"
	}

	uart_restart();									// UART ̎擾ĊJ

	while(1){

		if(gGPS_1sec_flag != 0){								// for PbM
			gGPS_1sec_flag = 0;
			tim_10ms_exist_gps1s = 10;
		}
		if(req_disp == 1){										// \vnm̎
			disp_dot8x8_all();									// WW S\
			req_disp = 0;										// \vnee
		}
		us = get_action_sw();									// XCb`Ԃ
		us &= SW_MASK;											// XCb`ɂ
		ucinf = get_infrared_data();							// ԊORfqf[^
		if(us == 0){											// XCb`ĂȂ
			us = trans_if_to_sw(ucinf);							// ԊORf[^XCb`f[^ɕϊ
		}

		if(us == SW1_OFF_LONG){									// ꂽ(set switch)
			disp_clear_oled_G();								// Clear All Display
			if(disp_gps_rx_data_req == 0){						// forMf[^\Ȃ
				disp_gps_rx_data_req = 1;						// forMf[^\
			}else{
				disp_gps_rx_data_req = 0;						// forMf[^\Ȃ
				old_GPS_year = 0xff;
				old_GPS_mon = 0xff;
				old_GPS_day = 0xff;
				old_GPS_hou = 0xff;
				old_GPS_min = 0xff;
				old_GPS_sec = 0xff;
				if(gDISP_sec_mode == 3){						// b̉o[\
					disp_sec_bar_scale();						// o[pڐ\
				}

			}
		}else if(us == SW1_OFF_SHORT){							// Zꂽ(set switch)
			if(disp_gps_rx_data_req == 100){
				disp_gps_rx_data_req = 1;
			}else if(disp_gps_rx_data_req == 1){
				disp_gps_rx_data_req = 100;
			}
		}else if(us == SW2_OFF_SHORT){							// Zꂽ(select switch)
			proc_no_key_timeup(1);								// L[͂L
			switch(disp_clock_mode){							// 샂[hύX
			 case HM:
				disp_clock_mode = MD;
				old_GPS_year = 0xff;
				old_GPS_mon = 0xff;
				old_GPS_day = 0xff;
				old_GPS_hou = 0xff;
				old_GPS_min = 0xff;
				old_GPS_sec = 0xff;
				break;
			 case MD:
				disp_clock_mode = YE;
				old_GPS_year = 0xff;
				old_GPS_mon = 0xff;
				old_GPS_day = 0xff;
				old_GPS_hou = 0xff;
				old_GPS_min = 0xff;
				old_GPS_sec = 0xff;
				break;
			 case YE:
				disp_clock_mode = HM;
				old_GPS_year = 0xff;
				old_GPS_mon = 0xff;
				old_GPS_day = 0xff;
				old_GPS_hou = 0xff;
				old_GPS_min = 0xff;
				old_GPS_sec = 0xff;
				break;
			 default:
				disp_clock_mode = HM;
				old_GPS_year = 0xff;
				old_GPS_mon = 0xff;
				old_GPS_day = 0xff;
				old_GPS_hou = 0xff;
				old_GPS_min = 0xff;
				old_GPS_sec = 0xff;
				break;
			}
			req_gps_data_set = 1;								// \f[^̃Zbgvnm
		}else{
			gps_data_ari = get_gps_clock_data();				// forvf[^擾iO[oϐɓj
			if(gps_data_ari != 0){								// forf[^
// Debug Signal -------------
				debsig_on();
// ---------------------------
				gps_data_ari = 0;
				exist_gps = 1;									// forL
				tim_1s_no_gps = 60;								// forf[^̗P\^CAbvp 60sec
				clock_add_9hour();								// XԐi߂
				gps_wday = subZeller((2000+((gGPS_year >> 4)*10)+(gGPS_year & 0x0f)), (((gGPS_mon >> 4)*10)+(gGPS_mon & 0x0f)), (((gGPS_day >> 4)*10)+(gGPS_day & 0x0f)) );	// cF[̌
				tim_10ms_blink = 50;
				req_gps_data_set = 1;							// \f[^̃Zbgvnm
			}else{
				if(exist_gps == 0){								// for
					if(tim_10ms_blink == 0){
						tim_10ms_blink = 50;
						disp_gps_moji ^= 1;
					}
					if(disp_gps_moji == 1){
						disp_dot8x8_moji(5,'-');					// 
						disp_dot8x8_moji(6,'G');					// 
						disp_dot8x8_moji(7,'P');					// 
						disp_dot8x8_moji(8,'S');					// 
						disp_dot8x8_moji(9,'-');					// 
					}else{
						disp_dot8x8_moji(5,' ');					// 
						disp_dot8x8_moji(6,' ');					// 
						disp_dot8x8_moji(7,' ');					// 
						disp_dot8x8_moji(8,' ');					// 
						disp_dot8x8_moji(9,' ');					// 
					}
					req_disp = 1;									// \vnm
				}
			}

			if(req_gps_data_set != 0){							// forf[^̃ZbgvL̎nm
				ad6_get_data();									// 邳̂`^cl𕽋ςĎ擾if[^ ad6_ave)
				req_gps_data_set = 0;
				if(old_GPS_year != gGPS_year){					// Nω
					old_GPS_year = gGPS_year;
					req_disp_year = 1;
				}
				if(old_GPS_mon != gGPS_mon){					// ω
					old_GPS_mon = gGPS_mon;
					req_disp_mon_day = 1;
				}
				if(old_GPS_day != gGPS_day){					// ω
					old_GPS_day = gGPS_day;
					req_disp_mon_day = 1;
				}
				if(old_GPS_hou != gGPS_hou){					// ω
					old_GPS_hou = gGPS_hou;
					req_disp_hou_min = 1;
				}
				if(old_GPS_min != gGPS_min){					// ω
					old_GPS_min = gGPS_min;
					req_disp_hou_min = 1;
					gGPS_1sec_count = 0;
					if((gDISP_sec_mode == 3)&&(disp_gps_rx_data_req == 0)){	// forMf[^\ȂŁAb͉o[\̎
						disp_sec_bar(0,1);						// o[\ bgp
					}
				}
				if(old_GPS_sec != gGPS_sec){					// bω
					old_GPS_sec = gGPS_sec;
					req_disp_sec = 1;
				}
				if(disp_clock_mode == YE){						// N[h
					tim_10ms_anime = 50;
					if(req_disp_year != 0){						// Nω
						disp_dot8x8_moji(4, (0x10 + gps_wday));	// j\
						disp_dot8x8_number(5, 15);				// 
						disp_dot8x8_tow(6,0x20);				// NiQOj \
						disp_dot8x8_tow(8,gGPS_year);			// N \
						req_disp = 1;							// \vnm
					}
				}else if(disp_clock_mode == MD){				// [h
					if(req_disp_mon_day != 0){					// ω
						disp_dot8x8_moji(4, (0x10 + gps_wday));	// j\
						disp_dot8x8_tow(5,gGPS_mon);			//  \
						disp_dot8x8_moji(7,'-');				// 
						disp_dot8x8_tow(8,gGPS_day);			//  \
						req_disp = 1;							// \vnm
					}
				}else if(disp_clock_mode == HM){				// [h
					if(req_disp_hou_min != 0){					// ω
						disp_dot8x8_moji(4, (0x10 + gps_wday));	// j\
						disp_dot8x8_tow(5,gGPS_hou);			//  \
						disp_dot8x8_moji(7,':');				// 
						disp_dot8x8_tow(8,gGPS_min);			//  \
						req_disp = 1;							// \vnm
					}

					if((gGPS_min == 0)&&(gGPS_sec == 0)){		// ̎
						old_disp_clock_mode = disp_clock_mode;
						disp_clock_mode = ANIME;
						disp_animation(1);						// Aj[V
					}

				}else if(disp_clock_mode == Infr_Data){			// ԊOMf[^[h̎
					disp_dot8x8_number(4, 15);					// 
					disp_dot8x8_moji(5,'I');					// 'I'
					disp_dot8x8_4binary(6,Ginf_data);			// S\iXXXX܂Łj
					req_disp = 1;								// \vnm
				}

				// nkdc\
				if(req_disp_year != 0){							// Nω
					req_disp_year = 0;
					if(disp_gps_rx_data_req == 0){				// forMf[^\Ȃ
						oled_disp_year();						// abc N\ (OLED)
					}
				}
				if(req_disp_mon_day != 0){						// ω
					req_disp_mon_day = 0;
					if(disp_gps_rx_data_req == 0){				// forMf[^\Ȃ
						oled_disp_mon_day();					// abc \ (OLED)
					}
				}
				if(req_disp_hou_min != 0){						// ω
					req_disp_hou_min = 0;
					if(disp_gps_rx_data_req == 0){				// forMf[^\Ȃ
						oled_disp_hou_min();					// abc \ (OLED)
					}
				}
				if(req_disp_sec != 0){							// bω
					req_disp_sec = 0;
					if(disp_gps_rx_data_req == 0){				// forMf[^\Ȃ
						if(gDISP_sec_mode == 1){				// b̐l\
							oled_disp_sec();					// abc b\ (OLED)
						}else if((gDISP_sec_mode == 3)&&(disp_gps_rx_data_req == 0)){	// forMf[^\ȂŁAb͉o[\̎
							disp_sec_bar(gGPS_sec,1);			// o[\ bgp
						}

						if(gDISP_sec_mode != 3){
							oled_disp_binary(4*6,7*8,ad6_ave);		// ݂̂`^cl̕\
						}
					}
				}

				// ÐM̏o
				if(dark == 1){									// Â
					if (ad6_ave < (600 - 50)){					// 邭ȂH
						dark_sig_off();							// Dark signal OFF
						disp_one_char_oled_G(20*6, 7*8, ' ');
						if(gDISP_sec_mode != 3){
							oled_disp_binary(4*6,7*8,ad6_ave);		// ݂̂`^cl̕\
						}
						dark = 0;
					}
				}else{											// 邢
					if ((600 + 50) < ad6_ave){					// ÂȂH
						dark_sig_on();							// Dark signal ON
						disp_one_char_oled_G(20*6, 7*8, 'D');
						dark = 1;
					}
				}

			}

			if(exist_gps != 0){									// forL
				if(tim_1s_no_gps == 0){							// forf[^P\^CAbv
					exist_gps = 0;								// forƂ
				}
			}


			if(gGPS_rx_data_ari != 0){							// \p̂forMf[^
				if(disp_gps_rx_data_req == 1){					// forMf[^\鎞
					disp_gps_rx_data();							// fobOpforf[^̕\
				}
				gGPS_rx_data_ari = 0;
			}

// Debug Signal -------------
			debsig_off();
// ---------------------------

			if (proc_no_key_timeup(0) == 0xff){						// ԃL[͂
				if((disp_clock_mode != HM)&& (disp_clock_mode != ANIME)){	// \ŖŁAAjł
					disp_clock_mode = HM;
					old_GPS_year = 0xff;
					old_GPS_mon = 0xff;
					old_GPS_day = 0xff;
					old_GPS_hou = 0xff;
					old_GPS_min = 0xff;
					old_GPS_sec = 0xff;
				}
			}

			if(tim_10ms_anime == 0){							// TOO
				if(disp_clock_mode == ANIME){					// Aj[V̎
					tim_10ms_anime = 20;						// POOr^C}[d|
					if(disp_animation(0) == 1){					// \
						disp_clock_mode = old_disp_clock_mode;
						old_GPS_year = 0xff;
						old_GPS_mon = 0xff;
						old_GPS_day = 0xff;
						old_GPS_hou = 0xff;
						old_GPS_min = 0xff;
						old_GPS_sec = 0xff;
					}
				}
			}
		}

		if(tim_10ms_exist_gps1s != 0){						// forPbԊuMLiforf[^Ԋuj
			led5_on();										// LED5 ON
			if(disp_gps_rx_data_req == 0){					// forMf[^\Ȃ
				if((gDISP_sec_mode == 2)||(gDISP_sec_mode == 12)){	// b̈\(12:Œ)
					disp_sec_blink(1);						// bL\
					gDISP_sec_mode = 22;					// b̈\(22:_)
				}
			}
		}else{
			led5_off();										// LED5 OFF
			if(disp_gps_rx_data_req == 0){					// forMf[^\Ȃ
				if(gDISP_sec_mode == 22){					// b̈\(22:_)
					disp_sec_blink(0);						// bL\ 
					gDISP_sec_mode = 12;					// b̈\(12:Œ)
				}
			}
		}
	}
}

//***************************
//  Main
//***************************
int	main(void)
{
	unsigned char	uc;

	PRR |= ( (1 << PRTWI) | (1 << PRSPI) | (1 << PRUSART0)  | (1 << PRTIM0) | (1 << PRTIM1) | (1 << PRTIM2) | (1 << PRADC) );	// TWI, SPI, UART0, UART1, Timer0, Timer1, Timer2, ADC ~
	delay_ms(500);									// 500mS Delay


	init_dot8x8();									//  8x8 dot\ 
	sw_init();										// XCb`֌W̏ݒ
	led5_init();									// kdcT֌W̏ݒ
	timer2_init();									// Timer2 Initial
	init_oled_G();									// Init. OLED
	dark_sig_init();								// Port-C Bit3 : Output

	gBPS_600 = read_eep_bps_600();					// ddoqnl BPS_600 ǂݏo
	gBPS_9600 = read_eep_bps_9600();				// ddoqnl BPS_9600 ǂݏo
	gDISP_sec_mode = read_eep_DISP_sec_mode();		// ddoqnl DISP_sec_mode ǂݏo
	
	oled_disp_title_and_version();					// Title & Version \ (OLED)

	g_keta = KETA_MAX;								// KETA = 14

	for(uc=0; uc<14; uc++){							// PO_
		led5_toggle();								// red LED ](ON->OFF,OFF->ON)
		delay_ms(500);								// 500mS Delay
		if((SW_IN_PORT & SW1_ON_BIT) == 0){				// XCb`f[^Ă(set switch)
			delay_ms(20);								// 20mS Delay
			if((SW_IN_PORT & SW1_ON_BIT) == 0){			// QxXCb`f[^Ă(set switch)
				setting();							//  ݒ
//				check_bps600();							// UOOaor̒l`FbN
			}
		}
	}

// `FbNp@||||
//	sei();											// 荞݉
//
//	for(uc=0; uc<10; uc++){							// PO_
//		led5_on();									// red LED ON
//		delay_ms(100);								// 100mS Delay
//		led5_off();									// red LED OFF
//		delay_ms(100);								// 100mS Delay
//	}
//
//	tim_10ms_blink=100;								// \uNpPOrPʃ^C}[ 1sec
//	disp_dot8x8_moji(9,'H');						// 'H'
//	disp_dot8x8_all();								// WW S\
//
//	for(;;){
//		if(tim_10ms_blink==0){						// \uNpPOrPʃ^C}[
//			tim_10ms_blink=200;						// \uNpPOrPʃ^C}[ 2sec
//			led5_toggle();
//		}
//		us = get_action_sw();									// XCb`Ԃ
//		us &= SW_MASK;											// XCb`ɂ
//		if(us == SW1_OFF_SHORT){						// Zėꂽ(set switch)
//			led5_off();									// red LED OFF
//			disp_dot8x8_moji(9,'B');					// 'B'
//			disp_dot8x8_all();							// WW S\
//		}
//		if(us == SW2_OFF_SHORT){						// Zėꂽ(select switch)
//			led5_on();									// red LED ON
//			disp_dot8x8_moji(9,'A');					// 'B'
//			disp_dot8x8_all();							// WW S\
//		}
//	}

	main_6_keta_gps();									//  Uij{S{Rj p Main

}
